"""@package docstring
B-ASIC Signal Module.
"""
from typing import TYPE_CHECKING, Optional
if TYPE_CHECKING:
	from b_asic import OutputPort, InputPort

class Signal:
	"""A connection between two ports."""
	_source: "OutputPort"
	_destination: "InputPort"

	def __init__(self, src: Optional["OutputPort"] = None, dest: Optional["InputPort"] = None):
		self._source = src
		self._destination = dest

	@property	
	def source(self) -> "InputPort":
		return self._source

	@property
	def destination(self) -> "OutputPort":
		return self._destination

	@source.setter
	def source(self, src: "Outputport") -> None:
		self._source = src

	@destination.setter
	def destination(self, dest: "InputPort") -> None:
		self._destination = dest

	def disconnect_source(self) -> None:
		self._source = None

	def disconnect_destination(self) -> None:
		self._destination = None

